aa2codon_table = {
    'phe': ['ttt', 'ttc'],
    'leu': ['tta', 'ttg', 'ctt', 'ctc', 'cta', 'ctg'],
    'ile': ['att', 'atc', 'ata'],
    'met': ['atg'],
    'val': ['gtt', 'gtc', 'gta', 'gtg'],
    'ser': ['tct', 'tcc', 'tca', 'tcg', 'agt', 'agc'],
    'pro': ['cct', 'ccc', 'cca', 'ccg'],
    'thr': ['act', 'acc', 'aca', 'acg'],
    'ala': ['gct', 'gcc', 'gca', 'gcg'],
    'tyr': ['tat', 'tac'],
    'stop': ['taa', 'tag', 'tga'],
    'his': ['cat', 'cac'],
    'gln': ['caa', 'cag'],
    'asn': ['aat', 'aac'],
    'lys': ['aaa', 'aag'],
    'asp': ['gat', 'gac'],
    'glu': ['gaa', 'gag'],
    'cys': ['tgt', 'tgc'],
    'trp': ['tgg'],
    'arg': ['cgt', 'cgc', 'cga', 'cgg', 'aga', 'agg'],
    'gly': ['ggt', 'ggc', 'gga', 'ggg']
}

codon2aa_table = {
    'aaa': 'lys',
    'aag': 'lys',
    'tta': 'leu',
    'ttg': 'leu',
    'ctt': 'leu',
    'ctc': 'leu',
    'cta': 'leu',
    'ctg': 'leu',
    'gaa': 'glu',
    'gag': 'glu',
    'caa': 'gln',
    'cag': 'gln',
    'cat': 'his',
    'cac': 'his',
    'aat': 'asn',
    'aac': 'asn',
    'tct': 'ser',
    'tcc': 'ser',
    'tca': 'ser',
    'tcg': 'ser',
    'agt': 'ser',
    'agc': 'ser',
    'cgt': 'arg',
    'cgc': 'arg',
    'cga': 'arg',
    'cgg': 'arg',
    'aga': 'arg',
    'agg': 'arg',
    'tgg': 'trp',
    'gct': 'ala',
    'gcc': 'ala',
    'gca': 'ala',
    'gcg': 'ala',
    'tgt': 'cys',
    'tgc': 'cys',
    'ggt': 'gly',
    'ggc': 'gly',
    'gga': 'gly',
    'ggg': 'gly',
    'gat': 'asp',
    'gac': 'asp',
    'ttt': 'phe',
    'ttc': 'phe',
    'atg': 'met',
    'tat': 'tyr',
    'tac': 'tyr',
    'gtt': 'val',
    'gtc': 'val',
    'gta': 'val',
    'gtg': 'val',
    'act': 'thr',
    'acc': 'thr',
    'aca': 'thr',
    'acg': 'thr',
    'cct': 'pro',
    'ccc': 'pro',
    'cca': 'pro',
    'ccg': 'pro',
    'att': 'ile',
    'atc': 'ile',
    'ata': 'ile',
    'taa': 'stop',
    'tag': 'stop',
    'tga': 'stop'
}

sense_codons_list = [
    'tct', 'atc', 'tgc', 'tgg', 'ttc', 'tcg', 'gca', 'tcc', 'aga', 'tca',
    'tac', 'caa', 'tgt', 'ata', 'ctc', 'ctt', 'atg', 'cgt', 'gta', 'ctg',
    'ttt', 'gct', 'cta', 'att', 'gat', 'ggt', 'acc', 'gtt', 'cga', 'tat',
    'cgc', 'aag', 'cgg', 'gcc', 'aaa', 'ggg', 'gga', 'ggc', 'gag', 'acg',
    'ttg', 'gac', 'ccg', 'gaa', 'gtc', 'aca', 'gtg', 'gcg', 'aac', 'cct',
    'cag', 'agc', 'cat', 'aat', 'agg', 'tta', 'act', 'cac', 'agt', 'cca', 'ccc'
]


default_cai_table = {
    'ttt': 0.296,
    'ttg': 0.02,
    'ttc': 1,
    'tta': 0.2,
    'tgt': 0.5,
    'tgg': 1,
    'tgc': 1,
    'tga': 1,
    'tct': 1,
    'tcg': 0.017,
    'tcc': 0.744,
    'tca': 0.077,
    'tat': 0.239,
    'tag': 1,
    'tac': 1,
    'taa': 1,
    'gtt': 1,
    'gtg': 0.221,
    'gtc': 0.066,
    'gta': 0.495,
    'ggt': 1,
    'ggg': 0.019,
    'ggc': 0.724,
    'gga': 0.01,
    'gct': 1,
    'gcg': 0.424,
    'gcc': 0.122,
    'gca': 0.586,
    'gat': 0.434,
    'gag': 0.259,
    'gac': 1,
    'gaa': 1,
    'ctt': 0.042,
    'ctg': 1,
    'ctc': 0.037,
    'cta': 0.007,
    'cgt': 1,
    'cgg': 0.004,
    'cgc': 0.356,
    'cga': 0.004,
    'cct': 0.07,
    'ccg': 1,
    'ccc': 0.012,
    'cca': 0.135,
    'cat': 0.291,
    'cag': 1,
    'cac': 1,
    'caa': 0.124,
    'att': 0.185,
    'atg': 1,
    'atc': 1,
    'ata': 0.003,
    'agt': 0.085,
    'agg': 0.002,
    'agc': 0.41,
    'aga': 0.004,
    'act': 0.965,
    'acg': 0.099,
    'acc': 1,
    'aca': 0.076,
    'aat': 0.051,
    'aag': 0.253,
    'aac': 1,
    'aaa': 1
}

default_tai_tuller = {
    'gtc': 0.25,
    'acc': 0.25,
    'aca': 0.125,
    'gtg': 0.2,
    'act': 0.10975,
    'aac': 0.5,
    'cct': 0.054875,
    'tgg': 0.165,
    'agc': 0.125,
    'aag': 0.24,
    'cat': 0.054875,
    'aat': 0.2195,
    'gtt': 0.10975,
    'cac': 0.125,
    'acg': 0.29,
    'agt': 0.054875,
    'cca': 0.125,
    'ccg': 0.165,
    'ccc': 0.125,
    'ggt': 0.2195,
    'tct': 0.10975,
    'atg': 1.0,
    'cga': 0.054875,  #5e-05,
    'cag': 0.33,
    'tga': 0.125,
    'tat': 0.164625,
    'cgg': 0.125,
    'tcg': 0.165,
    'agg': 0.165,
    'ggg': 0.165,
    'gga': 0.125,
    'tca': 0.125,
    'gaa': 0.5,
    'gag': 0.16,
    'tcc': 0.25,
    'tac': 0.375,
    'gac': 0.375,
    'tgt': 0.054875,
    'ata': 0.163204,
    'gca': 0.375,
    'ctt': 0.054875,
    'gta': 0.625,
    'ggc': 0.5,
    'gcg': 0.12,
    'atc': 0.375,
    'ctg': 0.54,
    'taa': 0.163204,
    'gct': 0.10975,
    'aga': 0.125,
    'cta': 0.125,
    'gcc': 0.25,
    'aaa': 0.75,
    'att': 0.164625,
    'caa': 0.25,
    'ttt': 0.10975,
    'cgt': 0.5,
    'cgc': 0.36,
    'tgc': 0.125,
    'tag': 0.163204,
    'ctc': 0.125,
    'ttg': 0.165,
    'tta': 0.125,
    'gat': 0.164625,
    'ttc': 0.25
}
